#ifndef MYAPPLICATION_INCLUDED
#define MYAPPLICATION_INCLUDED

#pragma once

#include "GapiApplication.h"

//-----------------------------------------------------------------------------
// Name: class CMyApplication
// Desc: Main class to run this application. Most functionality is inherited
//       from the CGapiApplication base class.
//-----------------------------------------------------------------------------
class CMyApplication : public CGapiApplication
{
// Construction
public:
	CMyApplication(const GDAPPCONFIG& config);

// Attributes
protected:
	CGapiBitmapFont* m_font;
	CGapiSurface*    m_ipaq;
	CGapiSurface*    m_taskbar;
	CGapiCursor*     m_cursor;
	RECT             m_btnMinimize;
	RECT             m_btnRotate;
	RECT             m_btnClose;

// Operations
protected:
	HRESULT DrawFrameInfo(CGapiSurface* pSurface, DWORD dwY, const _TCHAR* pText, COLORREF color);

// Implementation
public:
	virtual HRESULT InitInstance();
	virtual HRESULT ExitInstance();
	virtual HRESULT OnMinimize();
	virtual HRESULT OnRestore();
	virtual HRESULT CreateSysMemSurfaces(CGapiDisplay* pDisplay, HINSTANCE hInstance);
	virtual HRESULT CreateVidMemSurfaces(CGapiDisplay* pDisplay, HINSTANCE hInstance);
	virtual HRESULT ProcessNextFrame(CGapiSurface* pBackBuffer, DWORD dwFlags);

	virtual HRESULT KeyDown(DWORD dwKey, GDKEYLIST& keylist);
	virtual HRESULT KeyUp(DWORD dwKey, GDKEYLIST& keylist);
	virtual HRESULT StylusDown(POINT p);
	virtual HRESULT StylusUp(POINT p);
	virtual HRESULT StylusDblClk(POINT p);
	virtual HRESULT StylusMove(POINT p);
	virtual HRESULT Panel1(CGapiSurface* pBackBuffer);
	virtual HRESULT Panel2(CGapiSurface* pBackBuffer);

	int mode;


	virtual ~CMyApplication();
};

#endif // MYAPPLICATION_INCLUDED
